/*
   Copyright 2018-2019 Zephyr Software, LLC.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/

namespace IRDB_SDK
{
	using namespace std;
	using BasicBlockEdge_t    =  tuple<BasicBlock_t*, BasicBlock_t*>;
	using BasicBlockEdgeSet_t =  set<BasicBlockEdge_t> ;

	class CriticalEdges_t
	{
		protected:
			CriticalEdges_t(){}	
			CriticalEdges_t(const CriticalEdges_t& copy) = delete;
		public:
			static unique_ptr<CriticalEdges_t> factory(
			                                           const ControlFlowGraph_t &p_cfg, 
			                                           const bool p_conservative=true
			                                          );

			virtual const BasicBlockEdgeSet_t& getAllCriticalEdges() const = 0;
	};

}
