/*
   Copyright 2018-2019 Zephyr Software, LLC.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

*/
namespace IRDB_SDK
{

	using namespace std;

	class DatabaseError_t : virtual public exception 
	{
		protected:
		public: 
			enum DatabaseErrorType_t {VariantNotInDatabase, VariantTableNotRegistered};
	};

	ostream& operator<<(ostream& output, const DatabaseError_t& p);


	// an interface to a database
	class DBinterface_t
	{
		protected:
			DBinterface_t() {}
			DBinterface_t(const DBinterface_t& copy) = delete;
		public:
			virtual ~DBinterface_t() {};

			virtual void   issueQuery(string query)        = 0;
			virtual void   moveToNextRow()                 = 0;
			virtual string getResultColumn(string colname) = 0;
			virtual bool   isDone()                        = 0;
			virtual void   commit()                        = 0;

	};

}
